package org.processmining.dataawarereplayer.precision.state;

import org.processmining.models.graphbased.directed.petrinet.elements.Transition;

public final class StateTransitionResourceAndActivityImpl implements StateTransition, TransitionAwareStateTransition {

	private final Transition activity;
	private final String resource;

	public StateTransitionResourceAndActivityImpl(Transition activity, String resource) {
		this.activity = activity;
		this.resource = resource;
	}

	public int hashCode() {
		final int prime = 31;
		int result = 1;
		result = prime * result + ((activity == null) ? 0 : activity.hashCode());
		result = prime * result + ((resource == null) ? 0 : resource.hashCode());
		return result;
	}

	public boolean equals(Object obj) {
		if (this == obj)
			return true;
		if (obj == null)
			return false;
		if (!(obj instanceof StateTransitionResourceAndActivityImpl))
			return false;
		StateTransitionResourceAndActivityImpl other = (StateTransitionResourceAndActivityImpl) obj;
		if (activity == null) {
			if (other.activity != null)
				return false;
		} else if (!activity.equals(other.activity))
			return false;
		if (resource == null) {
			if (other.resource != null)
				return false;
		} else if (!resource.equals(other.resource))
			return false;
		return true;
	}

	public String toString() {
		return activity.getLabel() + "+" + resource;
	}

	@Override
	public Transition getActivity() {
		return activity;
	}
	
}