package org.processmining.models.DCNet;

import org.processmining.models.DCNet.DCNet.Position;
import org.processmining.models.cnet.CNetNode;
import org.processmining.plugins.DataConformance.framework.ReplayableActivity;

public class DCNetNode extends CNetNode implements ReplayableActivity
{
	private String guard="1";
	private String resourceGuard="";
	private String resourceSet;
	public final static DCNetNode emptyNode=new DCNetNode("");

	public DCNetNode(String label) {
		super(label);
	}


	public String toString() 
	{
		if (this.equals(emptyNode))
			return "EMPTYNODE";
		else
			return getLabel();
	}

	public String getGuard() {
		return guard+resourceGuard;
	}

	public void setGuard(String guard) 
	{
		if (guard.trim().equals(""))
			this.guard="1";
		else
			this.guard = guard;
	}
	
	@Override
	public int hashCode()
	{
		if (label.equals(""))
			return label.hashCode();
		else
			return super.hashCode();
	}

	@Override
	public boolean equals(Object o)
	{
		if (!(o instanceof DCNetNode))
			return false;
		DCNetNode other=(DCNetNode)o;
		if (label.equals("") && other.label.equals(""))
			return true;
		else
			return super.equals(other);
	}
	
	public int compareTo(CNetNode other) 
	{
		if (this.equals(other)) 
			return 0;
		else
			return super.compareTo(other);
	}	
	

	public void setExecutor(String resourceName, String resourceSet) {
		this.resourceSet=resourceSet;
		if (DCNet.OUTPUTVAR_IDENTIFIER_POS==Position.AFTER)
			resourceName=resourceName+DCNet.OUTPUTVAR_IDENTIFIER;
		else
			resourceName=DCNet.OUTPUTVAR_IDENTIFIER+resourceName;
		resourceGuard=" && belongsTo("+resourceName+", \""+resourceSet+"\")";
	}

	public String getResourceSet() {
		return resourceSet;
	}
}
