package org.processmining.plugins.DataConformance.Analyze.PetriNet;

import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.Set;

import org.processmining.models.FunctionEstimator.Type;

public final class TupleSet {
	
	private final Map<String,Type> attributesNames;
	private final List<Map<String,Object>> instances;
	private final String classAttribute;
	private final Map<String, Set<String>> literalAttributeValues;
	 
	public TupleSet(Map<String,Type> attributeNames, String classAttribute, Map<String,Set<String>> literalAttributeValues) {
		super();
		this.attributesNames = attributeNames;
		this.instances = new ArrayList<>();
		this.classAttribute=classAttribute;
		this.literalAttributeValues=literalAttributeValues;
	}
	
	public void addInstance(Map<String,Object> instance) {
		instances.add(instance);
	}

	public Map<String,Type> getAttributesNames() {
		return attributesNames;
	}

	public List<Map<String,Object>> getInstances() {
		return instances;
	}

	public String getClassAttribute() {
		return classAttribute;
	}

	public Map<String, Set<String>> getLiteralAttributeValues() {
		return literalAttributeValues;
	}
	
}
