package org.processmining.plugins.DataConformance.test;

import java.util.HashSet;
import java.util.Set;

import org.processmining.contexts.uitopia.UIPluginContext;
import org.processmining.models.DCNet.DCNet;
import org.processmining.models.DCNet.DCNetNode;


public class Example 
{
/*	@Plugin(name = "Data-aware Casual Net - Loan Example",
			parameterLabels = {},
			returnLabels = { "Data-aware Casual Net"},
			returnTypes = { DCNet.class },
			userAccessible = true,
			help = "Data-aware Casual Net ")
			@UITopiaVariant(affiliation = UITopiaVariant.EHV, author = "M. de Leoni", email = "m.d.leoni@tue.nl")*/
	public static DCNet dataConformance(UIPluginContext context) 
	{
		DCNet instance=new DCNet("My example");
		instance.setLengthShortestTrace(5);
		
		//instance.addSet("ALRequesters","MZRequesters","Requesters","Amounts","Fees","Bool");
		instance.addValuesToSet("ALRequesters",	"Anna","Fabrizio","Claudio","Jennifer");
		instance.addValuesToSet("MZRequesters", "Sahel","Massimo","Sara","Michael");
		instance.addValuesToSet("Requesters", instance.getSetValues("ALRequesters").toArray(new Comparable[0]));
		instance.addValuesToSet("Requesters", instance.getSetValues("MZRequesters").toArray(new Comparable[0]));

		instance.addValuesToSet("Amounts", 1000,2000,3000,4000,5000,6000,7000,8000,9000,10000);
		instance.addValuesToSet("Amounts", 11000,12000,13000,14000,15000,16000,17000,18000,19000,20000);
		instance.addValuesToSet("Amounts", 21000,22000,23000,24000,25000,26000,27000,28000,29000,30000);
		instance.addValuesToSet("Amounts", 31000,32000,33000,34000,35000,36000,37000,38000,39000,40000);
		instance.addValuesToSet("Amounts", 41000,42000,43000,44000,45000,46000,47000,48000,49000,50000);

		instance.addValuesToSet("Fees", 600,800,1000,1200,1400,1600,1800,2000,2200,2400,2600,2800,3000,3200,3400,3600,3800,4000);
		instance.addValuesToSet("Fees", 4200,4400,4600,4800,5000,5200,5400,5600,5800,6000);

		instance.addValuesToSet("Bool", false, true);
		
		instance.addVariable("requester","Requesters");
		instance.addVariable("amount","Amounts");
		instance.addVariable("fee","Fees");
		instance.addVariable("ok","Bool");
			
		//FOR CONSIDERING RESOURCES
		//instance.addSet("Manager","Expert","Assistant","Participants");
		instance.addValuesToSet("Manager", "Simon");
		instance.addValuesToSet("Expert", "Sue", "Sean");
		instance.addValuesToSet("Assistant", "Pete","Mike","Ellen");
		instance.addValuesToSet("Participants", instance.getSetValues("Manager").toArray(new Comparable[0]));
		instance.addValuesToSet("Participants", instance.getSetValues("Expert").toArray(new Comparable[0]));
		instance.addValuesToSet("Participants", instance.getSetValues("Assistant").toArray(new Comparable[0]));
		instance.setResourceSet("Participants");
		
		DCNetNode nodeA=new DCNetNode("Credit Request");
		nodeA.setGuard("$requester != \"\" && $amount>=0");
		
		DCNetNode nodeB=new DCNetNode("Verify");
		DCNetNode nodeC=new DCNetNode("Advanced Assessment");
		nodeC.setGuard("amount > 5000 && $fee>=0.15 * amount && $fee<=0.2 * amount");

		DCNetNode nodeD=new DCNetNode("Simple Assessment");
		nodeD.setGuard("amount <= 5000 && $fee>=0.1 * amount && $fee<=0.15 * amount");
		DCNetNode nodeE=new DCNetNode("Inform Customer M-Z");
		nodeE.setGuard("belongsTo(requester,\"MZRequesters\")");
		DCNetNode nodeF=new DCNetNode("Inform Customer A-L");
		nodeF.setGuard("belongsTo(requester,\"ALRequesters\")");
		DCNetNode nodeG=new DCNetNode("Open the credit loan");
		nodeG.setGuard("ok == 1");
		DCNetNode nodeH=new DCNetNode("End");

		instance.addNode(nodeA,"Assistant");
		instance.addNode(nodeB,"Expert");
		instance.addNode(nodeC,"Expert");
		instance.addNode(nodeD,"Assistant");
		instance.addNode(nodeE,"Assistant");
		instance.addNode(nodeF,"Assistant");
		instance.addNode(nodeG,"Manager");
		instance.addNode(nodeH);
		
		instance.addNonAffectingVariables("fee", nodeD);
		instance.addNonAffectingVariables("fee", nodeC);
		instance.addNonAffectingVariables("requester", nodeA);
		
		Set<DCNetNode> nodeA_OUT=new HashSet<DCNetNode>();
		nodeA_OUT.add(nodeB);
		instance.addOutputBinding(nodeA,"",nodeA_OUT);
		
		Set<DCNetNode> nodeB_IN=new HashSet<DCNetNode>();
		nodeB_IN.add(nodeA);
		instance.addInputBinding(nodeB,"",nodeB_IN);
		
		Set<DCNetNode> nodeB_OUT1=new HashSet<DCNetNode>();
		nodeB_OUT1.add(nodeC);
		instance.addOutputBinding(nodeB,"",nodeB_OUT1);
		
		Set<DCNetNode> nodeB_OUT2=new HashSet<DCNetNode>();
		nodeB_OUT2.add(nodeD);
		instance.addOutputBinding(nodeB,"",nodeB_OUT2);
		
		Set<DCNetNode> nodeC_IN = new HashSet<DCNetNode>();
		nodeC_IN.add(nodeB);
		instance.addInputBinding(nodeC,"",nodeC_IN);
		
		Set<DCNetNode> nodeC_OUT1=new HashSet<DCNetNode>();
		nodeC_OUT1.add(nodeE);
		instance.addOutputBinding(nodeC,"$ok == 0",nodeC_OUT1);
		
		Set<DCNetNode> nodeC_OUT2=new HashSet<DCNetNode>();
		nodeC_OUT2.add(nodeF);
		instance.addOutputBinding(nodeC, "$ok == 0",nodeC_OUT2);
		
		Set<DCNetNode> nodeC_OUT3=new HashSet<DCNetNode>();
		nodeC_OUT3.add(nodeE);
		nodeC_OUT3.add(nodeG);
		instance.addOutputBinding(nodeC, "$ok == 1",nodeC_OUT3);
		
		Set<DCNetNode> nodeC_OUT4=new HashSet<DCNetNode>();
		nodeC_OUT4.add(nodeF);
		nodeC_OUT4.add(nodeG);
		instance.addOutputBinding(nodeC, "$ok == 1",nodeC_OUT4);
		
		Set<DCNetNode> nodeD_IN = new HashSet<DCNetNode>();
		nodeD_IN.add(nodeB);
		instance.addInputBinding(nodeD,"",nodeD_IN);
		
		Set<DCNetNode> nodeD_OUT1=new HashSet<DCNetNode>();
		nodeD_OUT1.add(nodeE);
		instance.addOutputBinding(nodeD,"$ok == 0",nodeD_OUT1);
		
		Set<DCNetNode> nodeD_OUT2=new HashSet<DCNetNode>();
		nodeD_OUT2.add(nodeF);
		instance.addOutputBinding(nodeD,"$ok == 0",nodeD_OUT2);
		
		Set<DCNetNode> nodeD_OUT3=new HashSet<DCNetNode>();
		nodeD_OUT3.add(nodeE);
		nodeD_OUT3.add(nodeG);
		instance.addOutputBinding(nodeD,"$ok == 1",nodeD_OUT3);
		
		Set<DCNetNode> nodeD_OUT4=new HashSet<DCNetNode>();
		nodeD_OUT4.add(nodeF);
		nodeD_OUT4.add(nodeG);
		instance.addOutputBinding(nodeD, "$ok == 1",nodeD_OUT4);
		
		Set<DCNetNode> nodeE_IN1=new HashSet<DCNetNode>();
		nodeE_IN1.add(nodeC);
		instance.addInputBinding(nodeE,"",nodeE_IN1);

		Set<DCNetNode> nodeE_IN2=new HashSet<DCNetNode>();
		nodeE_IN2.add(nodeD);
		instance.addInputBinding(nodeE,"",nodeE_IN2);
		
		Set<DCNetNode> nodeE_OUT=new HashSet<DCNetNode>();
		nodeE_OUT.add(nodeH);
		instance.addOutputBinding(nodeE,"",nodeE_OUT);
		
		Set<DCNetNode> nodeF_IN1=new HashSet<DCNetNode>();
		nodeF_IN1.add(nodeC);
		instance.addInputBinding(nodeF,"",nodeF_IN1);

		Set<DCNetNode> nodeF_IN2=new HashSet<DCNetNode>();
		nodeF_IN2.add(nodeD);
		instance.addInputBinding(nodeF,"",nodeF_IN2);
		
		Set<DCNetNode> nodeF_OUT=new HashSet<DCNetNode>();
		nodeF_OUT.add(nodeH);
		instance.addOutputBinding(nodeF,"",nodeF_OUT);
				
		Set<DCNetNode> nodeG_IN1=new HashSet<DCNetNode>();
		nodeG_IN1.add(nodeC);
		instance.addInputBinding(nodeG,"",nodeG_IN1);

		Set<DCNetNode> nodeG_IN2=new HashSet<DCNetNode>();
		nodeG_IN2.add(nodeD);
		instance.addInputBinding(nodeG,"",nodeG_IN2);
		
		Set<DCNetNode> nodeG_OUT=new HashSet<DCNetNode>();
		nodeG_OUT.add(nodeH);
		instance.addOutputBinding(nodeG,"",nodeG_OUT);
		
		Set<DCNetNode> nodeH_IN1=new HashSet<DCNetNode>();
		nodeH_IN1.add(nodeE);
		instance.addInputBinding(nodeH,"",nodeH_IN1);
		
		Set<DCNetNode> nodeH_IN2=new HashSet<DCNetNode>();
		nodeH_IN2.add(nodeF);
		instance.addInputBinding(nodeH,"",nodeH_IN2);		

		Set<DCNetNode> nodeH_IN3=new HashSet<DCNetNode>();
		nodeH_IN3.add(nodeF);
		nodeH_IN3.add(nodeG);
		instance.addInputBinding(nodeH,"",nodeH_IN3);			

		Set<DCNetNode> nodeH_IN4=new HashSet<DCNetNode>();
		nodeH_IN4.add(nodeE);
		nodeH_IN4.add(nodeG);
		instance.addInputBinding(nodeH,"",nodeH_IN4);			
			
		instance.setStartNode(nodeA);
		instance.setEndNode(nodeH);
		
		return instance ;
	}
}
