package org.processmining.plugins.DataConformance.visualization.grouping;

import java.util.Collection;
import java.util.Comparator;

import org.processmining.framework.util.ui.widgets.traceview.ProMTraceList;
import org.processmining.framework.util.ui.widgets.traceview.ProMTraceView.Event;
import org.processmining.framework.util.ui.widgets.traceview.ProMTraceView.Trace;
import org.processmining.plugins.DataConformance.visualization.alignment.AlignmentTrace.DeviationsSetting;
import org.processmining.plugins.DataConformance.visualization.alignment.AlignmentTrace.InvisibleSetting;
import org.processmining.plugins.DataConformance.visualization.grouping.GroupedAlignments.AlignmentGroup;

public class GroupedAlignmentView extends ProMTraceList<AlignmentGroup> {

	private static final long serialVersionUID = 1L;

	private static final class AlignmentGroupTraceBuilder implements TraceBuilder<AlignmentGroup> {

		public Trace<? extends Event> build(AlignmentGroup element) {
			return element.getRepresentative(InvisibleSetting.VISIBLE, DeviationsSetting.NORMAL, false);
		}

	}

	public GroupedAlignmentView(Collection<AlignmentGroup> alignmentGroups) {
		this(alignmentGroups, GroupedAlignments.GroupOrdering.COUNT_DESC);
	}

	public GroupedAlignmentView(Collection<AlignmentGroup> alignmentGroups, Comparator<AlignmentGroup> ordering) {
		super(alignmentGroups, new AlignmentGroupTraceBuilder(), ordering);
	}

	@Deprecated
	public ProMTraceList<AlignmentGroup> getListView() {
		return this;
	}

	@Deprecated
	public Comparator<AlignmentGroup> getListOrdering() {
		return GroupedAlignments.GroupOrdering.COUNT_DESC;
	}

}
