package org.processmining.plugins.balancedconformance.controlflow.override.storage;

import org.processmining.plugins.balancedconformance.controlflow.override.DRecord;

import it.unimi.dsi.fastutil.Hash;
import it.unimi.dsi.fastutil.Hash.Strategy;
import it.unimi.dsi.fastutil.objects.ObjectOpenCustomHashSet;
import it.unimi.dsi.fastutil.objects.ObjectSet;

public final class ConsideredStatesStoreImpl implements ConsideredStatesStore {

	private final ObjectSet<DRecord> consideredStates;

	public ConsideredStatesStoreImpl(Strategy<DRecord> hashStrategy, int initialCapacity) {
		consideredStates = new ObjectOpenCustomHashSet<>(initialCapacity, Hash.VERY_FAST_LOAD_FACTOR, hashStrategy);
	}

	public void add(DRecord record) {
		consideredStates.add(record);
	}

	public boolean contains(DRecord record) {
		return consideredStates.contains(record);
	}

}