package org.processmining.plugins.balancedconformance.controlflow.override.storage;

import gnu.trove.map.TObjectIntMap;

import java.util.List;

import nl.tue.astar.Delegate;
import nl.tue.astar.Record;
import nl.tue.astar.Tail;
import nl.tue.astar.impl.JavaCollectionStorageHandler;
import nl.tue.astar.impl.State;

import org.processmining.plugins.astar.petrinet.impl.PHead;

public final class JavaCollectionStorageHandlerUnsynchronized<T extends Tail> extends
		JavaCollectionStorageHandler<PHead, T> {

	public JavaCollectionStorageHandlerUnsynchronized(Delegate<PHead, T> delegate,
			TObjectIntMap<PHead> head2int, List<State<PHead, T>> stateList) {
		super(delegate, head2int, stateList);
	}

	@Override
	public void storeStateForRecord(State<PHead, T> state, Record newRec) {
		int newIndex;
		newIndex = stateList.size() + 1;
		stateList.add(state);
		head2int.put(state.getHead(), newIndex);
		newRec.setState(newIndex - 1);
	}

	@Override
	public long getIndexOf(PHead head) {
		return head2int.get(head) - 1;
	}
}