package org.processmining.plugins.balancedconformance.controlflow.override.storage;

import nl.tue.astar.AStarException;
import nl.tue.astar.Record;
import nl.tue.astar.Tail;
import nl.tue.astar.impl.State;
import nl.tue.astar.impl.memefficient.MemoryEfficientAStarAlgorithm;
import nl.tue.astar.impl.memefficient.MemoryEfficientStorageHandler;
import nl.tue.storage.StorageException;
import nl.tue.storage.impl.CompressedStoreHashSetImpl.Result;

import org.processmining.plugins.astar.petrinet.impl.PHead;

public final class MemoryEfficientStorageHandlerUnsynchronized<T extends Tail> extends
		MemoryEfficientStorageHandler<PHead, T> {

	public MemoryEfficientStorageHandlerUnsynchronized(MemoryEfficientAStarAlgorithm<PHead, T> algorithm) {
		super(algorithm);
	}

	@Override
	public long getIndexOf(PHead head) throws AStarException {
		try {
			return statespace.contains(new State<PHead, T>(head, null));
		} catch (StorageException e) {
			throw new AStarException(e);
		}
	}

	@Override
	public void storeStateForRecord(State<PHead, T> state, Record newRec) throws AStarException {
		final Result<State<PHead, T>> r;
		try {
			r = statespace.add(state);
		} catch (StorageException e) {
			throw new AStarException(e);
		}
		newRec.setState(r.index);
	}
}