package org.processmining.plugins.balancedconformance.dataflow.lp;

import net.sf.javailp.Linear;
import net.sf.javailp.Operator;
import net.sf.javailp.Result;
import net.sf.javailp.Solver;

public interface ILPProblem {

	Result solve(Solver solver);
	
	void addObjective(double coefficient, String varName);

	int getObjectiveSize();
	
	void addORConstraints(Linear lhs, Operator operator, Number rhs);
	
	void addGuardConstraints(Linear lhs, Operator operator, Number rhs);
	
	void addNullConstraint(String ilpVarName, Linear linear, Operator operator, Number rhs);
	
	double writeNullConstraint(String ilpVarName, boolean wasNull);
	
	void addAssignmentConstraint(Linear lhs, Operator operator, Number rhs);

	int getConstraintsCount();
	
	void setVarLowerBound(String varName, double lowerBound);
	
	Number getVarLowerBound(String varName);

	void setVarUpperBound(String varName, double upperBound);
	
	Number getVarUpperBound(String varName);

	void setVarType(String varName, Class<?> type);

	Class<?> getVarType(String varName);

	boolean hasNullConstraint(String ilpVariable);

}